<template>
  <section>
    <h2>1er pilier</h2>
    <p>Le 1er pilier se compose de l'AVS (assurance-vieillesse et survivants) et de l'AI (assurance-invalidité), ainsi que des prestations complémentaires (PC). S'y ajoutent les allocations pour perte de gain (APG) notamment pendant le service militaire et la maternité, ainsi que l'assurance-chômage.</p>
    <div class="two-columns">
      <div class="two-columns--item">
        <p>Ici nous allons:</p>
        <ol class="info-nav">
          <li :class="{'info-strong': state == 0}">Demander à l’utilisateur son numéro AVS et sa date de naissance</li>
          <li :class="{'info-strong': state == 1}">Sauvegarder ces information</li>
          <li :class="{'info-strong': state == 2}">Récupérer les rentes de la prévoyance étatique  (1er pilier)</li>
        </ol>
        <NuxtLink class="button--strong" tag="button" to="/openpk" v-if="state == 3">Continuer ➜</NuxtLink>

      </div>
      <div class="two-columns--item">
        <loading :active.sync="isLoading" :is-full-page="fullPage" />
        <fieldset>
          <label for="navs">Numéro AVS</label>
          <div class="hint">7561234567891</div>
          <input id="navs" type="text" v-model="navs" placeholder="7561234567891"></input>
          <label for="birthdate">Date d'anniversaire</label>
          <div class="hint">02/01/1963</div>
          <input id="birthdate" type="date" v-model="birthdate" placeholder="Date d'anniversaire"></input>
        </fieldset>
        <template v-if="navs && birthdate">
          <label></label>
          <button v-if="!isSaved" @click="onSave">2. Sauvegarder les infos</button>
          <button v-else-if="!calculator" @click="onGetInfo">3. Récupérer vos informations</button>
          <button v-else @click="onGetInfo">4. Rafraichir vos informations</button>
        </template>
        <template v-if="isSaved && calculator">
          <pre>{{calculator}}</pre>
        </template>
      </div>
    </div>
  </section>
</template>

<script>
  import Loading from 'vue-loading-overlay'
  import { mapMutations } from 'vuex'

  export default {
    components: {
      Loading,
    },
    data () {
      return {
        fullPage: false,
        isLoading: true,
        navs: null,
        birthdate: null,
        data: null
      }
    },
    computed: {
      state() {
        if (this.isLoading && (!this.navs || !this.birthdate)) return -1;
        if (!this.navs || !this.birthdate) return 0;
        if (!this.isSaved) return 1;
        if (!this.calculator) return 2;

        return 3;
      },
      calculator () {
        return this.$store.state.openak.calculator
      },
      savedNavs () {
        return this.$store.state.openak.navs
      },
      savedBirthdate () {
        return this.$store.state.openak.birthdate
      },
      isSaved () {
        return (this.navs == this.savedNavs)
        && (this.savedBirthdate == this.birthdate);
      }
    },
    mounted () {
      this.$nuxt.$emit('check-if-connected')
      this.$nuxt.$once('user-is-connected', this.init)
    },
    methods: {
      ...mapMutations({
        setNavs: 'openak/setNavs',
        setBirthdate: 'openak/setBirthdate',
        setCalculator: 'openak/setCalculator'
      }),
      _getPensionCalculatorInfo() {
        return this.$api.get('/openak/pension-calculator/info')
      },
      _getPensionCalculator() {
        return this.$api.get('/openak/pension-calculator')
      },
      _savePensionCalculatorInfo(info) {
        return this.$api.post('/openak/pension-calculator/info', info)
      },
      init () {
        this._getPensionCalculatorInfo().then((info) => {
          this.setNavs(info.navs);
          this.setBirthdate(info.birthdate);
          this.navs = info.navs;
          this.birthdate = info.birthdate;

          this.isLoading = false;
        })
      },
      onSave() {
        this.isLoading = true;

        this._savePensionCalculatorInfo({
          navs: this.navs,
          birthdate: this.birthdate,
        }).then(() => {
          this.isLoading = false;
          this.data = null;
          this.setCalculator(null);
          this.setNavs(this.navs);
          this.setBirthdate(this.birthdate);
          this.onGetInfo();
        }, 300).catch(() => {
          this.isLoading = false;
        })
      },
      onGetInfo() {
        this.isLoading = true;

        this._getPensionCalculator().then((data) => {
          this.setCalculator(data);
          this.isLoading = false;
          this.data = data;
        }, 300).catch(() => {
          this.isLoading = false;
          alert("La récupération des données chez OpenAK ne fonctionne pas. Veuillez vérifier vos données s'il vous plait");
        })
      },
    }
  }
</script>
